[dp] poj 1015 Jury Compromise

题目链接:

http://poj.org/problem?id=1015


Jury Compromise

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 24438   Accepted: 6352   Special Judge

Description

In Frobnia, a far-away country, the verdicts in court trials are determined by a jury consisting of members of the general public. Every time a trial is set to begin, a jury has to be selected, which is done as follows. First, several people are drawn randomly
from the public. For each person in this pool, defence and prosecution assign a grade from 0 to 20 indicating their preference for this person. 0 means total dislike, 20 on the other hand means that this person is considered ideally suited for the jury.

Based on the grades of the two parties, the judge selects the jury. In order to ensure a fair trial, the tendencies of the jury to favour either defence or prosecution should be as balanced as possible. The jury therefore has to be chosen in a way that is satisfactory
to both parties.

We will now make this more precise: given a pool of n potential jurors and two values di (the defence‘s value) and pi (the prosecution‘s value) for each potential juror i, you are to select a jury of m persons. If J is a subset of {1,..., n} with m elements,
then D(J ) = sum(dk) k belong to J

and P(J) = sum(pk) k belong to J are the total values of this jury for defence and prosecution.

For an optimal jury J , the value |D(J) - P(J)| must be minimal. If there are several jurys with minimal |D(J) - P(J)|, one which maximizes D(J) + P(J) should be selected since the jury should be as ideal as possible for both parties.

You are to write a program that implements this jury selection process and chooses an optimal jury given a set of candidates.

Input

The input file contains several jury selection rounds. Each round starts with a line containing two integers n and m. n is the number of candidates and m the number of jury members.

These values will satisfy 1<=n<=200, 1<=m<=20 and of course m<=n. The following n lines contain the two integers pi and di for i = 1,...,n. A blank line separates each round from the next.

The file ends with a round that has n = m = 0.

Output

For each round output a line containing the number of the jury selection round (‘Jury #1‘, ‘Jury #2‘, etc.).

On the next line print the values D(J ) and P (J ) of your jury as shown below and on another line print the numbers of the m chosen candidates in ascending order. Output a blank before each individual candidate number.

Output an empty line after each test case.

Sample Input

4 2
1 2
2 3
4 1
6 2
0 0 

Sample Output

Jury #1
Best jury has value 6 for prosecution and value 4 for defence:
 2 3 

Hint

If your solution is based on an inefficient algorithm, it may not execute in the allotted time.

Source

Southwestern European Regional Contest 1996

[Submit]   [Go Back]   [Status]  
[Discuss]

题目意思:

有n个人,每个人有个d值和p值,求选出m个人,使得|sum(d)-sum(p)|最小,如果最小值相同,则选择|sum(d)+sum(p)|较大的。输出选出的人。

n<=200 d,p<20 m<=20

解题思路:

dp,实际上就是一个背包。

|sum(d)-sum(p)|最小,实际上就是找能凑成的最靠近0的.由于-20=<d-p<=20,所以把每个d-p都加上20,变成非负的整数。然后算出最靠近20*m的就是满足要求的最小的。

dp[i][j]:表示当sum(d)-sum(p)为i,且有j个人时,能否凑成。保存一个add[i][j]:表示这j个人的sum(d)+sum(p)

最后在20*m附近找.

代码:

//#include<CSpreadSheet.h>

#include<iostream>
#include<cmath>
#include<cstdio>
#include<sstream>
#include<cstdlib>
#include<string>
#include<string.h>
#include<cstring>
#include<algorithm>
#include<vector>
#include<map>
#include<set>
#include<stack>
#include<list>
#include<queue>
#include<ctime>
#include<bitset>
#include<cmath>
#define eps 1e-6
#define INF 0x3f3f3f3f
#define PI acos(-1.0)
#define ll __int64
#define LL long long
#define lson l,m,(rt<<1)
#define rson m+1,r,(rt<<1)|1
#define M 1000000007
//#pragma comment(linker, "/STACK:1024000000,1024000000")
using namespace std;

#define Maxn 8100

int dp[Maxn][25],add[Maxn][25];
int savea[220],saveb[220];
vector<int>re[Maxn][25];
int n,m;

int main()
{
   //freopen("in.txt","r",stdin);
   //freopen("out.txt","w",stdout);
   int ca=0;

   while(scanf("%d%d",&n,&m)&&n+m)
   {
       for(int i=1;i<=n;i++)
           scanf("%d%d",&savea[i],&saveb[i]);
       memset(dp,0,sizeof(dp));
       memset(add,0,sizeof(add));
       dp[0][0]=1;

       int lim=20*n*2;
       for(int i=0;i<=lim;i++)
            for(int j=0;j<=m;j++)
                re[i][j].clear();

       for(int i=1;i<=n;i++)
       {
           int temp=savea[i]-saveb[i]+20;

           for(int j=lim;j>=temp;j--)
           {
               for(int k=m;k>=1;k--)
               {
                   if(dp[j-temp][k-1])
                   {
                       int te=add[j-temp][k-1]+savea[i]+saveb[i];
                       if(!dp[j][k])
                       {
                           add[j][k]=te;
                           re[j][k]=re[j-temp][k-1];
                           re[j][k].push_back(i);
                           dp[j][k]=1;
                       }
                       else if(te>add[j][k])
                       {
                           add[j][k]=te;
                           re[j][k]=re[j-temp][k-1];
                           re[j][k].push_back(i);
                       }
                   }
               }
           }
       }
       int ansa,ansb,a;

       int p=0,pp=20*m;
       int k=m;

       while(!dp[pp+p][k]&&!dp[pp-p][k])
           p++;
       if(!dp[pp+p][k])
       {
           ansa=abs((pp-p+add[pp-p][k]-20*m))/2;
           ansb=(add[pp-p][k]-pp+p+20*m)/2;
           a=pp-p;
           //printf("Best jury has value %d for prosecution and value %d for defence:\n",ansa,)
       }
       else if(!dp[pp-p][k])
       {
           ansa=abs((pp+p+add[pp+p][k]-20*m))/2;
           ansb=(add[pp+p][k]-pp-p+20*m)/2;
           a=pp+p;
       }
       else
       {
           if(add[pp+p][k]>add[pp-p][k])
           {
               ansa=abs((pp+p+add[pp+p][k]-20*m))/2;
               ansb=(add[pp+p][k]-pp-p+20*m)/2;
               a=pp+p;
           }
           else
           {
               ansa=abs((pp-p+add[pp-p][k]-20*m))/2;
               ansb=(add[pp-p][k]-pp+p+20*m)/2;
               a=pp-p;
           }
       }
       printf("Jury #%d\n",++ca);
       printf("Best jury has value %d for prosecution and value %d for defence:\n",ansa,ansb);
       for(int i=0;i<re[a][k].size();i++)
            printf(" %d",re[a][k][i]);
       printf("\n\n");
   }
   return 0;
}

[dp] poj 1015 Jury Compromise

时间: 2024-08-03 02:54:49

[dp] poj 1015 Jury Compromise的相关文章

[kuangbin 基础dp][POJ 1015] Jury Compromise(dp)

[kuangbin 基础dp][POJ 1015] Jury Compromise 题目 In Frobnia, a far-away country, the verdicts in court trials are determined by a jury consisting of members of the general public. Every time a trial is set to begin, a jury has to be selected, which is do

POJ 1015 Jury Compromise(dp坑)

提议:在遥远的国家佛罗布尼亚,嫌犯是否有罪,须由陪审团决定.陪审团是由法官从公众中挑选的.先随机挑选n个人作为陪审团的候选人,然后再从这n个人中选m人组成陪审团.选m人的办法是:控方和辩方会根据对候选人的喜欢程度,给所有候选人打分,分值从0到20.为了公平起见,法官选出陪审团的原则是:选出的m个人,必须满足辩方总分和控方总分的差的绝对值最小.如果有多种选择方案的辩方总分和控方总分的之差的绝对值相同,那么选辩控双方总分之和最大的方案即可. 题解:开始想到的是二维01背包,因为评价差的总分值最大可能

POJ 1015 Jury Compromise DP+记录路径

找每个点能转移出去的状态时要回溯到根去掉所有能转移的点来去重.. 可能这种做法在距离根距离较小的时候能用..(隐隐感觉有bug,还是人云亦云地做掉先了..) #pragma comment(linker, "/STACK:1024000000,1024000000") #include <cstdio> #include <cstring> #include <algorithm> #include <iostream> #include

POJ 1015 Jury Compromise 2个月后重做,其实这是背包题目

http://poj.org/problem?id=1015 题目大意:在遥远的国家佛罗布尼亚,嫌犯是否有罪,须由陪审团决定.陪审团是由法官从公众中挑选的.先随机挑选n个人作为陪审团的候选人,然后再从这n个人中选m人组成陪审团.选m人的办法是:控方和辩方会根据对候选人的喜欢程度,给所有候选人打分,分值从0到20.为了公平起见,法官选出陪审团的原则是:选出的m个人,必须满足辩方总分和控方总分的差的绝对值最小.如果有多种选择方案的辩方总分和控方总分的之差的绝对值相同,那么选辩控双方总分之和最大的方案

POJ 1015 Jury Compromise

链接:http://poj.org/problem?id=1015 参考:http://blog.csdn.net/lyy289065406/article/details/6671105 题意: 在遥远的国家佛罗布尼亚,嫌犯是否有罪,须由陪审团决定.陪审团是由法官从公众中挑选的.先随机挑选n 个人作为陪审团的候选人,然后再从这n 个人中选m 人组成陪审团.选m 人的办法是:控方和辩方会根据对候选人的喜欢程度,给所有候选人打分,分值从0 到20.为了公平起见,法官选出陪审团的原则是:选出的m 个

背包系列练习( hdu 2844 Coins &amp;&amp; hdu 2159 &amp;&amp; poj 1170 Shopping Offers &amp;&amp; hdu 3092 Least common multiple &amp;&amp; poj 1015 Jury Compromise)

作为一个oier,以及大学acm党背包是必不可少的一部分.好久没做背包类动规了.久违地练习下-.- dd__engi的背包九讲:http://love-oriented.com/pack/ 鸣谢http://blog.csdn.net/eagle_or_snail/article/details/50987044,这里有大部分比较有趣的dp练手题. hdu 2844 Coins 多重背包 就是一个10w的多重背包,每个物品的cost同时也作为value去做背包,我们求的是每个容量下的价值,所以没

K - Jury Compromise POJ 1015 (动态规划 --难)

K - Jury Compromise Time Limit:1000MS Memory Limit:65536KB 64bit IO Format:%I64d & %I64u Submit Status Practice POJ 1015 Description In Frobnia, a far-away country, the verdicts in court trials are determined by a jury consisting of members of the ge

POJ 1015 -- 陪审团人选

陪审团人选 Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 29543   Accepted: 7849   Special Judge 试题描述 在遥远的国家佛罗布尼亚,嫌犯是否有罪,须由陪审团决定.陪审团是由法官从公众中挑选的.先随机挑选n个人作为陪审团的候选人,然后再从这n个人中选m人组成陪审团.选m人的办法是:控方和辩方会根据对候选人的喜欢程度,给所有候选人打分,分值从0到20.为了公平起见,法官选出陪审团的原则是

Jury Compromise (POJ 1015) 难

http://poj.org/problem?id=1015 Description In Frobnia, a far-away country, the verdicts in court trials are determined by a jury consisting of members of the general public. Every time a trial is set to begin, a jury has to be selected, which is done